import { merge } from 'ramda';

import { CONNECTION_REFRESH, CONNECTION_SET, OFFLINE, ONLINE, RESUME, QUEUE_CLEAR_BACKOFF } from './const';
import { get as getMeta } from './meta';

export const refresh = () => ({
  type: CONNECTION_REFRESH,
});

export const middleware = (api) => (next) => (action) => {
  const site = getMeta(api.getState(), 'site');
  switch (action.type) {
    case CONNECTION_REFRESH:
    case OFFLINE:
    case ONLINE:
    case RESUME:
      if (site.isOnline()) {
        api.dispatch({ type: QUEUE_CLEAR_BACKOFF });
      }

      break;
  }

  return next(action);
};

export const reducer = (state = {}, action) => {
  switch (action.type) {
    case CONNECTION_SET:
      return merge(state, action.meta);
  }

  return state;
};
