import { externalFlag } from './utils';

const message = (severity, module, ...messages) => {
  if (!externalFlag('debug')) {
    return;
  }

  // eslint-disable-next-line no-console
  console[ severity ](`storyshare/${module}@${Date.now()}:`, ...messages);
};

export const warn = (module, ...messages) => message('warn', module, ...messages);

export const info = (module, ...messages) => message('info', module, ...messages);

export const error = (module, ...messages) => message('error', module, ...messages);

export const debug = (module, ...messages) => message('debug', module, ...messages);
