import Bluebird from 'bluebird';
import fs from 'mz/fs';
import os from 'os';
import fsPath from 'path';

export const rootDir = () => os.tmpdir();

const createNestedDirectory = async (path, root) => {
  // noinspection JSUnresolvedVariable
  const sep = fsPath.sep;
  const baseDir = root;

  await Bluebird.reduce(path.split(sep), async (parent, child) => {
    const current = fsPath.resolve(baseDir, parent, child);

    try {
      // noinspection JSUnresolvedFunction
      await fs.mkdir(current);
      // eslint-disable-next-line no-empty
    } catch (err) {
    }

    return current;
  }, '');
};

export const readFile = async (path) =>
  // noinspection JSUnresolvedFunction
  fs.readFile(`${rootDir()}/${path}`);

export const writeFile = async (path, data) => {
  await createNestedDirectory(fsPath.dirname(path), rootDir());

  // noinspection JSUnresolvedFunction
  return fs.writeFile(`${rootDir()}/${path}`, Buffer.from(data));
};

export const deleteFile = async (path) => {
  const target = `${rootDir()}/${path}`;

  if (await fs.exists(target)) {
    return fs.unlink(`${rootDir()}/${path}`);
  }
};
