import { REBOOT } from './const';
import * as platform from './platforms/reboot';

/**
 * Creates an action to reboot the application
 * @param {string} target - path to load on reboot (defaults to app root)
 * @returns {AnyAction}
 */
export const reboot = (target) => ({
  type: REBOOT,
  target,
});

export const middleware = (api) => (next) => (action) => {
  switch (action.type) {
    case REBOOT:
      platform.reboot(api, action.target);
  }

  return next(action);
};
