import { combineReducers } from 'redux';

import { reducer as analytics } from './analytics';
import { reducer as assets } from './asset';
import { reducer as auth } from './auth';
import { reducer as autoupdate } from './autoupdate';
import { reducer as connection } from './connection';
import { reducer as event } from './event';
import { reducer as fetch } from './fetch';
import { reducer as kv } from './kv';
import { reducer as meta } from './meta';
import { reducer as notification } from './notification';
import { reducer as objects } from './object';
import { reducer as promises } from './promise';
import { reducer as queue } from './queue';
import { reducer as schema } from './schema';
import { reducer as splashscreen } from './splashscreen';
import { reducer as version } from './version';

/**
 * Get the reducers required for an external store
 */
export const serialize = [
  'auth',
  'assets',
  'autoupdate',
  'kv',
  'notification',
  'objects',
  'queue',
  'schema',
  'version',
];

export const reducers = combineReducers({
  analytics,
  assets,
  auth,
  autoupdate,
  connection,
  event,
  fetch,
  kv,
  meta,
  notification,
  objects,
  promises,
  queue,
  schema,
  splashscreen,
  version,
});
